﻿Imports Microsoft.VisualBasic
Imports WiimoteLib
Public Class Form1
    Private Delegate Sub UpdateWiimoteStateDelegate(ByVal args As WiimoteChangedEventArgs)
    Private wm As New Wiimote
    Public Sub New()
        InitializeComponent()
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        AddHandler wm.WiimoteChanged, AddressOf wm_WiimoteChanged
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        wm.Connect()
        wm.SetReportType(InputReport.IRExtensionAccel, True)
        wm.SetLEDs(True, False, False, False)
    End Sub

    Private Sub wm_WiimoteChanged(ByVal sender As Object, ByVal args As WiimoteChangedEventArgs)
        UpdateState(args)
    End Sub
    Public Sub UpdateState(ByVal args As WiimoteChangedEventArgs)
        BeginInvoke(New UpdateWiimoteStateDelegate(AddressOf UpdateWiimoteChanged), args)
    End Sub

    Private Sub UpdateWiimoteChanged(ByVal args As WiimoteChangedEventArgs)
        Dim ws As WiimoteState = args.WiimoteState
        If ws.IRState.IRSensors(0).Found = True Then
            OvalShape1.FillColor = Color.Red
            OvalShape1.Left = 300 * ws.IRState.IRSensors(0).Position.X
            OvalShape1.Top = 300 - 300 * ws.IRState.IRSensors(0).Position.Y
            Label3.Text = ws.IRState.IRSensors(0).Position.X
            Label4.Text = ws.IRState.IRSensors(0).Position.Y
        Else
            OvalShape1.FillColor = Color.Silver
        End If
        If ws.IRState.IRSensors(1).Found = True Then
            OvalShape2.FillColor = Color.Red
            OvalShape2.Left = 300 * ws.IRState.IRSensors(1).Position.X
            OvalShape2.Top = 300 - 300 * ws.IRState.IRSensors(1).Position.Y
            Label5.Text = ws.IRState.IRSensors(1).Position.X
            Label6.Text = ws.IRState.IRSensors(1).Position.Y
        Else
            OvalShape2.FillColor = Color.Silver
        End If
        Label7.Text = Math.Sqrt((ws.IRState.IRSensors(0).Position.X - ws.IRState.IRSensors(1).Position.X) ^ 2 + (ws.IRState.IRSensors(0).Position.Y - ws.IRState.IRSensors(1).Position.Y) ^ 2)
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles MyBase.FormClosing
        wm.SetLEDs(False, False, False, False)
        wm.Disconnect()
    End Sub
End Class

